# @cjsx

Rev.Content.VersionCard = React.createClass
  getEventString: ->
    if @props.version.get('event').indexOf('rollback') > -1
      'Rollback'
    else if @props.version.get('event').indexOf('import') > -1
      'Import'
    else
      s = @props.version.get('event')
      s.charAt(0).toUpperCase() + s.slice(1)

  getInitialState: ->
    state =
      expanded: false

  truncatedContent: ->
    s = @props.version.get('reify').content
    if s? && s.length > 200
      <span>
        { s[0...200] }&nbsp;
        <a href="#" onClick={ => @setState expanded: true } className="Version-preview--containerExpand">[more…]</a>
      </span>
    else
      <span>{ s }</span>



  render: ->
    <div className="EditablePage">
      <Rev.Components.Form action="#{ Rev.Content.base_path }versions/#{ @props.version.id }/revert_all_to" method="DELETE">
        <button className="Button Rollback">Change to this version</button>
      </Rev.Components.Form>
      <ul className="EditablePage-contents">
        <div className="Version-rolledBack">
          <p>
            <strong>
              {
                @getEventString()
              }
              &nbsp;on:
            </strong>
            &nbsp;<Rev.Content.Timestamp datetime={ @props.version.get('created_at') } withTimeAgo />
          </p>
          {
            if @props.version.get('whodunnit')
              <p>
                <strong>By:</strong> { @props.version.get('whodunnit') }
              </p>
          }
        </div>

        <div className="Version-preview">
          {
            if @props.version.get('reify')?.src?
              <div className="Version-previewContainer">
                <img src={ @props.version.get('reify').src } />
              </div>
            else if @props.version.get('reify')?.content?
              <div className="Version-previewContainer--text">
                <span>
                  {
                    if @state.expanded
                      <span>{ @props.version.get('reify').content }</span>
                    else
                      <span>{ @truncatedContent() }</span>
                  }
                </span>
              </div>
          }
        </div>
      </ul>
    </div>

Rev.Content.RollbackGroup = React.createClass
  mixins: [Rev.Mixins.Core]

  getInitialState: ->
    state =
      open: false

  classes: ->
    this.classSet 'Versions-rollbackGroup': true, 'Versions-rollbackGroup--open': @state.open

  render: ->
    <div className={ @classes() }>
      <h5>
        Rollback on { moment(@props.rollbackGroup[0].get('created_at')).format('ddd M/D/YYYY') }
        {
          unless @state.open
            <button className="Button Rollback" onClick={ => @setState open: true }>Details</button>
        }
      </h5>
      <div className="Versions-rollbackGroup-details">
        {
          _(@props.rollbackGroup).map (version)=>
            <Rev.Content.VersionCard version={ version } />
        }
      </div>
    </div>

Rev.Content.VersionHistory = React.createClass
  getInitialState: ->
    state =
      versions: new Rev.Content.Models.Version.Collection()
      done: false

  getVersionGroups: ->
    groups = []
    currentDate = null
    currentGroup = null
    currentRollback = null
    @state.versions.each (version)=>
      unless moment(version.get('created_at')).isSame(currentDate, 'day')
        if currentRollback
          currentGroup.push currentRollback
        groups.push([currentDate, currentGroup]) if currentGroup
        currentDate = moment(version.get('created_at'))
        currentGroup = []
      if version.get('event').indexOf('rollback') > -1
        currentRollback = [] unless currentRollback
        currentRollback.push version
      else
        if currentRollback
          currentGroup.push currentRollback
          currentRollback = null
        currentGroup.push version

    if currentRollback
      currentGroup.push currentRollback
      currentRollback = null

    if currentGroup && currentGroup.length > 0
      groups.push([currentDate, currentGroup])
    groups

  render: ->
    <div className="Versions EditablePages">
      <h1>History</h1>
      {
        if @state.done
          @getVersionGroups().map (group)=>
            @renderDayGroup(group)
        else
          <Rev.Content.Loader />
      }
    </div>

  renderDayGroup: (dayGroup)->
    <div className="Versions-dayGroup">
      <h5>
        { dayGroup[0].format('ddd M/D/YYYY') }
      </h5>
      <div className="Versions-dayGroup-details">
        {
          _(dayGroup[1]).map (rollbackGroupOrVersion)=>
            if rollbackGroupOrVersion instanceof Array
              <Rev.Content.RollbackGroup rollbackGroup={ rollbackGroupOrVersion } />
            else
              <Rev.Content.VersionCard version={ rollbackGroupOrVersion } />
        }
      </div>
    </div>

  componentDidMount: ->
    @state.versions.once 'sync', =>
      @setState done: true
      @forceUpdate()
    @state.versions.fetch()
