require_dependency "revelry_content/application_controller"

module Revelry::Content
  class PagesController < ApplicationController
    include ::Revelry::Content::WithRevelryContent

    layout ->(_) { 'application' }

    def show
      render template: template_path
    end

    def template_path
      "templates/#{current_page.template}"
    end

    def current_page
      @_current_page ||= find_page
    end

    def find_page
      ::Revelry::Content::Page.find_by(slug: params[:id]) || raise(ActionController::RoutingError.new('Not Found'))
    end

    def content_scope
      ::Revelry::Content::Content.excluding_prefix('pages') +
      ::Revelry::Content::Content.prefix("pages.#{params[:id]}")
    end
  end
end
