module Revelry
  module Generators
    module Content
      class InstallGenerator < ::Rails::Generators::Base
        def add_migrations
          generate 'revelry:content:migrations'
          rake 'db:migrate'
        end

        def add_js_assets
          generate 'revelry:content:js'
        end

        def add_css_assets
          generate 'revelry:content:css'
        end

        def add_initializer
          generate 'revelry:content:initializer'
        end

        def add_route
          route 'mount Revelry::Content::Engine => "/revelry_content"'
        end

        def add_controller_concern
          insert_into_file app_controller, after: "ApplicationController < ActionController::Base\n" do
            "include Revelry::Content::WithRevelryContent\n"
          end
        end

        private

        def app_controller
          File.join('app', 'controllers', 'application_controller.rb')
        end
      end
    end
  end
end
