require 'rails/generators/migration'

module Revelry
  module Generators
    module Content
      class MigrationsGenerator < ::Rails::Generators::Base
        include Rails::Generators::Migration
        source_root File.expand_path('../templates', __FILE__)
        desc "add the migrations"

        def self.next_migration_number(path)
          unless @prev_migration_nr
            @prev_migration_nr = Time.now.utc.strftime("%Y%m%d%H%M%S").to_i
          else
            @prev_migration_nr += 1
          end
          @prev_migration_nr.to_s
        end

        def copy_migrations
          migration_template "create_revelry_content_contents.rb", "db/migrate/create_revelry_content_contents.rb"
          migration_template "create_versions.rb", "db/migrate/create_versions.rb"
          migration_template "create_revelry_content_pages.rb", "db/migrate/create_revelry_content_pages.rb"
        end
      end
    end
  end
end
