module Revelry::Content
  class Engine < ::Rails::Engine
    engine_name 'revelry_content'
    isolate_namespace Revelry::Content

    initializer 'revelry.content_autoload_path', before: :set_autoload_paths do
      config.autoload_paths << File.expand_path('../../', __FILE__)
    end

    CONFIG_ASSET = 'revelry_content/config'

    # Require the route config to load before we load the config (we need route
    # helpers to generate that file)
    initializer 'revelry.content_depend_on_routes', after: "sprockets.environment" do
      if Rails.application.assets.respond_to?(:register_preprocessor)
        routes = Rails.root.join('config','routes.rb')
        Rails.application.assets.register_preprocessor 'application/javascript', :'revelry.content_depend_on_routes' do |ctx,data|
          require routes if ctx.logical_path == CONFIG_ASSET
          data
        end
      end
    end
  end
end
