require 'jbuilder'
require 'ancestry'
require 'carrierwave'
require 'data_uri'
require 'open-uri'
require 'data_uri/open_uri'
require 'paper_trail'
require 'redcarpet'
require 'sanitize'
require 'sprockets'
require 'sprockets/coffee-react'
require 'sprockets/coffee-react-script'
require 'sprockets/coffee-react/engine'
require 'momentjs-rails'
require 'moment_timezone/rails'
require 'responders'
require 'revelry/content/engine'
require 'revelry/content/configuration'
require 'revelry/content/content_concern'
require 'revelry/content/admin_concern'
require 'revelry/content/contents_helper'
require 'revelry/content/railtie'
require 'generators/revelry/content/css_generator'
require 'generators/revelry/content/initializer_generator'
require 'generators/revelry/content/install_generator'
require 'generators/revelry/content/js_generator'
require 'generators/revelry/content/migrations_generator'

module Revelry
  module Content
    mattr_accessor :_config

    def self.configure(&block)
      block.call config
      if ActiveRecord::Base.connection.table_exists? 'revelry_content_contents'
        Revelry::Content::JsExporter.write_export if config.js_export
      end
      config
    end

    def self.config
      self._config ||= Configuration.new
    end
  end
end
